--
--  File: NBitAdder.vhd
--  created by Design Wizard: 06/17/99 14:05:27
--
entity NBitAdder is
generic (N: positive := 8);
port (A, B: in bit_vector (N-1 downto 0);
		cin: in bit;
		Y: out bit_vector (N-1 downto 0);
		cout: out bit);
end NBitAdder;


architecture Structure of NBitAdder is

component Adder
	port (a, b, cin: in bit;
		sum, cout: out bit);
end component;

signal Carry: bit_vector (N-1 downto 0);

begin
	NAdder: for index in 0 to N-1 generate
		Add1:	if index = 0 generate
				Add0:Adder
				port map (a => A(0),
						  b => B(0),
						  cin => cin,
						  sum => Y(0),
						  cout => Carry(0));
				end generate;
		Add: 	if index > 0 and index < N-1 generate
				Add:Adder
				port map (a => A(index),
						  b => B(index),
						  cin => Carry(index-1),
						  sum => Y(index),
						  cout => Carry(index));
				end generate;
		AddN:	if index = N-1 generate
				AddH:Adder
				port map (a => A(index),
						  b => B(index),
						  cin => Carry(index-1),
						  sum => Y(index),
						  cout => cout);
				end generate;
	end generate;
end Structure;

configuration Default of NBitAdder is
	for Structure
		for all:Adder use entity Work.Adder(Structure);
		end for;
	end for;
end Default;
